/*********************************************************************************************
 *							Algoritmid ja andmestruktuurid
 *						Arvutipraktikum 2017/2018 sgissemestril
 *						
 * 			Klass, milles on kirjeldatud rida graafi lbimisega seotud meetodeid 
 *
 *			Autorid: 
 *                 lli pilane -- meetodite saavutatavaid, lbida_sgavuti, otsida_kik_teed  
 *                                  ja lbida_Dijkstra kood (sisemine spetsifikatsioon)                                 
 *                 Jri Kiho    -- meetodid otsida_suvatee, lbida_Bellman_Ford ja 
 *                              	testimisotstarbeline peameetod ning kigi meetodite 
 *                              	vlised spetsifikatsioonid
 *
 *					            --- Kitlemine ksurealt (cmd) ---								
 *		Eeldus: jooksvas kaustas on failid Otsing.java (see fail, ANSI kodeeringus), 														*
 *	 			TeeInfo.java ja ee_ut_kiho_aa_.zip ning graafTeed.txt (testimiseks)															
 *			Kompileerimine:																		
 *				Kaustatee>javac -cp .\;ee_ut_kiho_aa_.zip Otsing.java
 *  		Lahendamine:
 *             	Kaustatee>java -cp .\;ee_ut_kiho_aa_.zip Otsing 
 *								
 *********************************************************************************************/

import ee.ut.kiho.aa.graaf.*;
import java.util.Vector;

public class Otsing{

	static int saavutatavaid(Graaf g, Tipp t){ // Etd GTE_1-2 //////////////////////////////
		// Antud: graaf g ja selle tipp t
		// Tulemus: tagastatakse tippude arv, mis on saavutatavad
		//        	sellest tipust lhtuvalt (incl tipp t);
		//        	tippudele seatakse vlju "lipp"
		// Eeldus: (veel saavutamata) tippudel puudub vli "lipp" 
		t.seadaVli("lipp", ""); // tipule t panna lipp 
		int loe = 1;
		
// ......................

		return 0; //liba
	}//saavutatavaid

	static void lbida_sgavuti(Graaf g, Tipp t){ // GTE_2-0 ////////////////////////////////// 
		// Antud: graaf g ja selle tipp t
		// Tulemus: igale tipust t saavutatavale tipu pandud vli "eellane" --
		//			selle tipu number, kust tippu t tuldi
		t.seadaVli("vaadeldud", "x"); // tipule t panna lipp "vaadeldud"
// .............................
	}// lbida_sgavuti
	
	static TeeInfo otsida_suvatee(Graaf g, Tipp a, Tipp b){ // GTE_2-1b 
		// Antud: graaf g, selle tipud a ja b
		// Tulemus: tagastatakse tipust a tippu b kulgeva tee info (TeeInfo isendina)
		lbida_sgavuti(g, a);
		return new TeeInfo(g, b); 
	}//otsida_suvatee
	
	static void otsida_kik_teed(Graaf g, Tipp t, Tipp b, Vector<TeeInfo> teed){ // GTE_2-3
		// Antud: graaf g, selle tipud t ja b
		//        ning koht 'teed' leitavate teede salvestamiseks
		// Tulemus: g tippudele on lisatud vlju "eellane" ja "vaadeldud"; listi 'teed' 
		//          salvestatakse kik teed (tagurpidi <b, b.eellane, ..., eellaseta tipp>)
		//          koos kogupikkusega
// ...........................
	}//otsida_kik_teed

/////////////////////////////////// DIJKSTRA:
	 static void lbida_Dijkstra(Graaf g, Tipp a){ // GTE_3
		// Antud: orienteeritud graaf G = (V, E) ja lhtetipp a,
		// .          millest arvestada teiste tippude kaugusi;
		// .          igal kaarel (v, w) on pikkus c(v, w) = kaar.nimi >= 0;
		// .       NB! Kui kaare (arvulist) pikkust ei ole, loetakse see =1.0
		// Tulemus:  on salvestatud tipuvljadesse .d ja .eellane
		// .              jrgmiselt:
		// .              iga tipu v korral on v.d lhima tee a...v pikkus ja
		// .              v.eellane on v-le eelnev tipp (tipu number)  sellel teel;
		// .              kui tipp v ei ole algustipust saavutatav, siis v.d = +lpmatus
		// .              ja vli v.eellane puudub; ka a.eellane puudub
// ..........................
	}//lbida_Dijkstra
	static double d(Tipp t){ // Dijkstra abimeetod
		// Antud: tipp t
		// Tulemus: tagastatkse selle tipu vljal "d" olev arv
		return Double.parseDouble(t.vli("d"));
	}
/////////////////////////////////// DIJKSTRA.

/////////////////////////////////// BELLMAN-FORD:
	static boolean lbida_Bellman_Ford(Graaf g, Tipp a){
		// [AA Kiho 2003, lk 102-104, joonis 6.10]
		// Antud: graaf g = (V, E) ja lhtetipp a, millest alustada
		//           g igal kaarel (v, w) on pikkus c(v, w) = kaar.nimi;
		//           kaare pikkus vib ka puududa: (v, w).nimi == "",
		//           siis loetakse pikkuseks 1.0
		// Tulemus: tagastatakse false, kui mne tipu kaugus lhtetipust on -lpmatus, 
		//          vastasel korral tagastatakse true ning siis graafis g
		//          iga tipust a saavutatava tipu v korral on v.d lhima tee a...v pikkus ja
		//          v.eellane on v-le eelnev tipp (tipu number)  sellel teel
		//          kui tipp v ei ole algustipust saavutatav, siis v.d = +lpmatus
		//          ja vli v.eellane puudub; ka a.eellane puudub
		parandada_kaugused_Bellman_Ford(g, a);
		for( int i = 0; i <= g.m()-1; i++ ){
			Kaar vw = g.kaar(i);
			Tipp v = vw.algus();
			Tipp w = vw.lpp();
			//uus_kaugus = int(v.vli("d")) + int(vw.nimi) 
			double uus_kaugus = Double.parseDouble(v.vli("d")) + ((vw.nimi() != "") ? Double.parseDouble(vw.nimi()) : 1.0);
			if(uus_kaugus < Double.parseDouble(w.vli("d"))){
				w.seadaVli("eellane", "" + g.indeks(v)+ 1);
				w.seadaVli("d", "" + uus_kaugus);
				return false;
			}
		}//for
        return true;
	}//lbida_Bellman_Ford
	static void parandada_kaugused_Bellman_Ford(Graaf g, Tipp a){
         // [AA Kiho 2003, lk 102-104, joonis 6.8]
         // Antud: graaf g = (V, E) ja lhtetipp a, millest alustada;
         //           g igal kaarel (v, w) on pikkus c(v, w) >= 0;
         //           kaare pikkus vib ka puududa: (v, w).nimi == "",
         //           siis loetakse pikkuseks 1.0
         // Tulemus:  on salvestatud tipuvljadesse .d ja .eellane jrgmiselt:
         //               iga tipu v korral on v.d lhima tee a...v pikkus ja
         //               v.eellane on v-le eelnev tipp (tipu number)  sellel teel;
         //               kui tipp v ei ole algustipust saavutatav, siis v.d = +lpmatus
         //               ja vli v.eellane puudub; ka a.eellane puudub
		for( int i = 0; i <= g.n()-1; i++ )
			g.tipp(i).seadaVli("d", "99999999.0");
        a.seadaVli("d", "0.0");
		for( int i = 1; i <= g.m()-1; i++ )
			for( int j = 0; j <= g.m()-1; j++ ){
                    Kaar vw = g.kaar(j);
                    Tipp v = vw.algus();
                    Tipp w = vw.lpp();
                    //uus_kaugus = int(v.vli("d")) + int(vw.nimi) ;
                    double uus_kaugus = Double.parseDouble(v.vli("d")) + ((vw.nimi() != "") ? Double.parseDouble(vw.nimi()) : 1.0);
				if (uus_kaugus < Double.parseDouble(w.vli("d"))){
					w.seadaVli("eellane", "" + (g.indeks(v)+1));
					w.seadaVli("d", "" + uus_kaugus);
				}
			}
	}//parandada_kaugused_Bellman_Ford
/////////////////////////////////// BELLMAN-FORD.

	public static void main(String[] args){ 
	// TEST saavutatavaid(), lbida_sgavuti(), otsida_kik_teed(), lbida_Dijkstra()
		String fNimi = "graafTeed.txt";
		Graaf g = Graaf.sisestadaTabelist(fNimi);
		new GraafiJoonistaja(fNimi);
		System.out.println("\nGraaf failist " + fNimi + ".\n");
		
		System.out.println("Saavutatavaid tipust 6: " + saavutatavaid(g, g.tipp(5)) );
		for(int i = 0; i < g.n(); i++) g.tipp(i).eemaldadaVli("lipp");
		
		TeeInfo tInf = otsida_suvatee(g, g.tipp(0), g.tipp(7)); // otsida ks tee 1..8 (testib meetodit lbida_sgavuti)
		System.out.println("Suvatee 1..8: \n\t<" + tInf + ">");
		for(int i = 0; i < g.n(); i++) g.tipp(i).seadaMrgend(g.tipp(i).mrgend00()); // tipud puhastada vljadest
		
		Vector<TeeInfo> teed = new Vector<TeeInfo>(); 		// koht leitavatele teedele
		otsida_kik_teed(g,  g.tipp(0), g.tipp(7), teed); 	// otsida kik teed 1..8
		System.out.println("Leitud teid 1..8: " + teed.size());
		for(TeeInfo tInfo : teed) System.out.println("\t<" + tInfo + ">"); // printida leitud teed					
		for(int i = 0; i < g.n(); i++) g.tipp(i).seadaMrgend(g.tipp(i).mrgend00()); // tipud puhastada vljadest
		
		lbida_Dijkstra(g,  g.tipp(0)); // seada (lhimate tagasiteede) vljad "eellane" lhtudes tipust 1 
		System.out.println("Dijkstra leitud lhim tee 1..8: \n\t<" + new TeeInfo(g, g.tipp(7)) + ">"); 
		for(int i = 0; i < g.n(); i++) g.tipp(i).seadaMrgend(g.tipp(i).mrgend00()); // tipud puhastada vljadest
		
	}//main

}//Otsing