/*********************************************************************************************
 *							Algoritmid ja andmestruktuurid
 *						Arvutipraktikum 2017/2018 sgissemestril
 *						
 * 		Klass, mille isendis hoitakse tee pikkust ja sellel olevate tippude numbreid
 *									Autor: Jri Kiho
 *
 *		Konstruktor 2 mrab tee (antud tippu) vljadega "eellane" varustatud graafis.
 *
 *					           --- Kitlemine ksurealt (cmd) ---								
 *		Eeldus: jooksvas kaustas on failid TeeInfo.java (see fail, ANSI kodeeringus)														*
 *	 			ja ee_ut_kiho_aa_.zip															
 *			Kompileerimine:																		
 *				Kaustatee>javac -cp .\;ee_ut_kiho_aa_.zip TeeInfo.java						
 *								
 *********************************************************************************************/

import ee.ut.kiho.aa.graaf.*;
import java.util.Vector;
class TeeInfo{
	// isendimuutujad:
	Double pikkus; // tee kogupikkus
	Vector<Integer> tipud_teel; // selle teel olevate tipunumbrite  list
	
	TeeInfo(Double p, Vector<Integer> tee){// konstruktor 1
		this.pikkus = p;
		this.tipud_teel = tee;
	}//konstruktor 1
	
	TeeInfo(Graaf g, Tipp b){// konstruktor 2
		// Antud: graaf g, mille tippudele on seatud vlju "eellane"
		//        ja tipp b, millest leida tee (tagurpidi mda eellasi) tipuni, 
		//		  millel ei ole vlja "eellane"
		// Tulemus: mratud isendivljad 
		pikkus = 0.0; // leitava tee kogupikkus
		tipud_teel = new Vector<Integer>(); // teel olevate tippude numbrid
        Tipp tt = b; // viimane teel
		while(tt.vli("eellane") != null){
			tipud_teel.add(0, g.indeks(tt)+1); // teele lisada tipu tt number
			Tipp t0 = tt; // kaare lpptipp
			tt = g.tipp(Integer.parseInt(tt.vli("eellane")) - 1) ; // tt := tt.eellane
			Kaar k = g.kaar(tt, t0);
			try{
				pikkus += Double.parseDouble(k.nimi()); // kogupikkusele lisada kaare tt-->t0 pikkus
			}
			catch (NumberFormatException e){
				pikkus += 1.0; // kaare pikkus vaikimisi 
			}
		}//while
		if(pikkus > 0) // kui tee ei olnud thi (tipul b oli eellane)
			tipud_teel.add(0, g.indeks(tt)+1 ); // esimene teel
	}//konstruktor 2
	
	public String toString(){
		return "" + Math.round(pikkus*100)/100.0 + " " + tipud_teel;	 
	}
	
	// piilumeetodid:
	 Double pikkus(){return pikkus;}
	 Vector<Integer> tipud_teel(){return tipud_teel;}		
}//TeeInfo